// LexicalAnalyzer.cpp: implementation of the CLexicalAnalyzer class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Viewer.h"
#include "LexicalAnalyzer.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CLexicalAnalyzer::CLexicalAnalyzer()
{

}

CLexicalAnalyzer::~CLexicalAnalyzer()
{

}

#define LETTER(x) ((x>='a' && x<='z') || (x>='A' && x<='z'))
#define DIGIT(x) (x>='0' && x<='9')
#define IGNORED(x) (x==' ' || x=='\n' || x=='\r' || x=='\t')

// Gets the next token
void CLexicalAnalyzer::GetToken(CToken &token)
{
	char *tokens[]={
		"struct","long","int","char","{","}",";"};
	char *ptr;
	ptr=token.m_Value;
	BOOL End=FALSE;
	while(IGNORED(m_NextChar))
	{
		if(m_NextChar=='\r')
			m_CurrentLine++;
		GetNextChar();
	}

	for(int i=OPEN_BRACE;i<=SEMI_COLON;i++)
		if(m_NextChar==tokens[i][0])
		{
			token.m_Type=i;
			GetNextChar();
			return;
		}
	if(m_EOF==TRUE)
	{
		token.m_Type=FILE_END_TOKEN;
		return;
	}
	
	if(!LETTER(m_NextChar))
	{
		token.m_Type=TOKEN_ERROR;
		return;
	}
	token.m_Type=USER_DEFINED;

	int current_digit_count=1;
	while(End!=TRUE)
	{
		*ptr=m_NextChar;
		if(!(LETTER(m_NextChar) || DIGIT(m_NextChar)))
		{
			current_digit_count++;
			if(current_digit_count==99)
			{
				token.m_Type=TOKEN_ERROR;
				return;
			}
			End=TRUE;
			*ptr=0;
		}
		else
			GetNextChar();
		*ptr++;
	}
	
	for(i=0;i<4;i++)
		if(strcmp(token.m_Value,tokens[i])==0)
		{
			token.m_Type=i;
			break;
		}
}

// Gets the next char and checks for end of file
void inline CLexicalAnalyzer::GetNextChar(void)
{
	if(m_HeaderFile.Read(&m_NextChar,1)!=1)
	{
		m_NextChar=END_OF_FILE;
		m_EOF=TRUE;
	}
}

// Opens the input file and initializes
BOOL CLexicalAnalyzer::OpenInputFile(LPCSTR lpFileName)
{
	if(m_HeaderFile.Open(lpFileName,CFile::modeRead|CFile::typeBinary)==FALSE)
		return FALSE;
	m_EOF=FALSE;
	m_CurrentLine=1;
	GetNextChar();
	return TRUE;
	
}

// Closes the input file 
void CLexicalAnalyzer::CloseInputFile(void)
{
	m_HeaderFile.Close();
}

// Current line number
int CLexicalAnalyzer::GetCurrentLine(void)
{
	return m_CurrentLine;
}