// LexicalAnalyzer.h: interface for the CLexicalAnalyzer class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_LEXICALANALYZER_H__0CDF4FE2_4D8F_11D3_9F2D_00605207E82D__INCLUDED_)
#define AFX_LEXICALANALYZER_H__0CDF4FE2_4D8F_11D3_9F2D_00605207E82D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Token.h"

// Token Definitions
#define STRUCT			0
#define LONG			1
#define INT				2
#define CHAR			3
#define OPEN_BRACE		4
#define CLOSE_BRACE		5
#define SEMI_COLON		6
#define USER_DEFINED	7
#define FILE_END_TOKEN		8
#define TOKEN_ERROR		100

#define END_OF_FILE		0

#define NUMBER_OF_TOKENS 6


class CLexicalAnalyzer  
{
public:
	CLexicalAnalyzer();
	virtual ~CLexicalAnalyzer();
	CFile m_HeaderFile;
	char m_NextChar;
	BOOL m_EOF;								// End of File Reached?
	BOOL OpenInputFile(LPCSTR lpFileName);	// Opens the input file
	void CloseInputFile(void);				// Closes the input file
	void GetToken(CToken &token);			// Gets the next token
	void inline GetNextChar(void);			// Gets the next char
	int GetCurrentLine(void);				// Gets the 
private:
	int m_CurrentLine;						// Current line number
};

#endif // !defined(AFX_LEXICALANALYZER_H__0CDF4FE2_4D8F_11D3_9F2D_00605207E82D__INCLUDED_)
