// ViewerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Viewer.h"
#include "ViewerDlg.h"
#include "Parser.h"
#include "DisplayDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

#define RECURSIVE_PARSING	0
#define LL1_PARSING			1

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewerDlg dialog

CViewerDlg::CViewerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CViewerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CViewerDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CViewerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CViewerDlg)
	DDX_Control(pDX, IDC_EDIT2, m_BinaryFileName);
	DDX_Control(pDX, IDC_EDIT1, m_HeaderFileName);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CViewerDlg, CDialog)
	//{{AFX_MSG_MAP(CViewerDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, OnView)
	ON_BN_CLICKED(IDC_BUTTON1, OnButtonHeaderBrowse)
	ON_BN_CLICKED(IDC_BUTTON2, OnButtonBinaryBrowse)
	ON_BN_CLICKED(IDCANCEL2, OnCancelAbout)
	ON_BN_CLICKED(IDC_BUTTON3, OnButtonWriteSamples)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CViewerDlg message handlers

BOOL CViewerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	((CButton *) GetDlgItem(IDC_RADIO1))->SetCheck(1);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CViewerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CViewerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CViewerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CViewerDlg::OnView() 
{
	// TODO: Add your control notification handler code here
	CParser parser;
	char buf[255];
	m_HeaderFileName.GetWindowText(buf,255);
	
	if(((CButton*)GetDlgItem(IDC_RADIO1))->GetCheck())
		parser.SetParsingType(RECURSIVE_PARSING);
	else
		parser.SetParsingType(LL1_PARSING);
	if(parser.ParseFile(buf)==FALSE)
		return;//);buf);
	if(parser.GetStructHead()==NULL)
	{
		AfxMessageBox("No structures defined in the file");
		return;
	}
	m_BinaryFileName.GetWindowText(buf,255);
	CDisplayDialog dlg;
	dlg.m_BinaryFileName=buf;
	dlg.m_Parser=&parser;
	dlg.DoModal();
}

void CViewerDlg::OnButtonHeaderBrowse() 
{
	// TODO: Add your control notification handler code here
	static char BASED_CODE szFilter[] = "Header Files (*.hdr)|*.hdr|All Files (*.*)|*.*||";
	CFileDialog *dlg;
	dlg=new CFileDialog (TRUE,NULL,NULL,NULL,szFilter,this);
	if(dlg->DoModal()==IDCANCEL)
		return;
	m_HeaderFileName.SetWindowText(LPCSTR(dlg->GetPathName()));
	delete dlg;
	
}

void CViewerDlg::OnButtonBinaryBrowse() 
{
	// TODO: Add your control notification handler code here
	static char BASED_CODE szFilter[] = "Binary Files (*.bin)|*.bin|All Files (*.*)|*.*||";
	CFileDialog *dlg;
	dlg=new CFileDialog (TRUE,NULL,NULL,NULL,szFilter,this);
	if(dlg->DoModal()==IDCANCEL)
		return;
	m_BinaryFileName.SetWindowText(LPCSTR(dlg->GetPathName()));
	delete dlg;	
}

void CViewerDlg::OnCancelAbout() 
{
	// TODO: Add your control notification handler code here
	CAboutDlg dlg;
	dlg.DoModal();
	
}


// The next function writes 7 header files (2 working & 5 with errors)
// 2 binary files to view with the working header files
void CViewerDlg::OnButtonWriteSamples() 
{
	// TODO: Add your control notification handler code here
	FILE *fptr;
	char *samples[]={"struct StructToUse {struct B StructB1;int a;} ; struct A{int a\n\r;char b;\n\rlong c;\n\r};\n\rstruct B {\n\rint x\n\r;struct A StructA1;\n\rlong y;\n\rstruct A StructA2;\n\rint z;\n\r};\n\r",
		"struct D {int x;int y;char c;} ;\n\r",
		"struct stA { int x; int y; struct stB s33;};\n\rstruct stB { struct stC s384;};\n\rstruct stC { struct stD s3499;};\n\rstruct stD { struct stB aasss;};\n\r",
		"struct structureA { int a; int d; int ds;};\n\rstruct structureA { int s; int w; int dds;};\n\r",
		"struct structureA { int a; int d int ds;};\n\rstruct structureA { int s; int w; int dds;};\n\r",
		"struct structure { };\n\r",
		"struct a {int a; struct b a;};\n\rstruct b {char a;};"};
	char *samplefilenames[]={
		"sample1.hdr",
		"sample2.hdr",
		"SampleError1.hdr",
		"SampleError2.hdr",
		"SampleError3.hdr",
		"SampleError4.hdr",
		"SampleError5.hdr"};
	
	struct A {int a;char b;long c;} ;
	struct B {int x;struct A StructA1;long y;struct A StructA2;int z;};
	struct C {struct B StructB1;int a;} a;

	fptr=fopen("sample1.bin","wb");
	for(int i=0;i<10;i++)
	{
		a.StructB1.x=i;
		a.StructB1.StructA1.a=i+100;
		a.StructB1.StructA1.b='A'+i;
		a.StructB1.StructA1.c=1000+i;
		a.StructB1.y=i+1;
		a.StructB1.StructA2.a=i+200;
		a.StructB1.StructA2.b='a'+i;
		a.StructB1.StructA2.c=2000+i;
		a.StructB1.z=i+2;
		a.a=9000+i;
		fwrite(&a,sizeof(struct C),1,fptr);
	}
	fclose(fptr);

	struct D {int x;int y;char c;} b;
	
	fptr=fopen("sample2.bin","wb");
	for(i=0;i<10;i++)
	{
		b.x=i;
		b.y=100-i;
		b.c='A'+i;	
		fwrite(&b,sizeof(struct D),1,fptr);
	}
	fclose(fptr);
	for(i=0;i<7;i++)
	{
		fptr=fopen(samplefilenames[i],"wb");
		fwrite(samples[i],strlen(samples[i]),1,fptr);
		fclose(fptr);
	}
	AfxMessageBox("Sample files successfully written in the current directory");
}
